unit UnitDFT;

interface

uses Classes;
const
    BufSize = 2000;   //   BufSize/discret = 50 msec
    DFT_nmax=BufSize;
    DFT_kmax=256;
type
    DFT_Koef= array[0..DFT_nmax-1,0..DFT_kmax-1] of integer;
    DFT_spectr = array[0..DFT_kmax-1] of integer;

 TDFT = class
  private
  public
    nmax:integer;
    kmax:integer;
    nkT:real;// 
    ADC:integer;
    T:real;
    Avg:real;
    sin_nmax,cos_nmax:TMemoryStream;
    K_sin,K_cos:DFT_Koef;
    fdata: array of integer;
    fspectr:DFT_spectr;
    constructor Create;
    Function ReDFTQ (kg:integer):real;
    Function ImDFTQ (kg:integer):real;
    Function ReDFTQ_Const (kg:integer):real;
    Function ImDFTQ_Const (kg:integer):real;
    Procedure Create_SinCos;
  end;

implementation

{*************************************************}
constructor TDFT.Create;
begin

  sin_nmax := TMemoryStream.Create;
  cos_nmax := TMemoryStream.Create;
 //  fint     := TMemoryStream.Create;

  sin_nmax.Seek(0, soFromBeginning);
  cos_nmax.Seek(0, soFromBeginning);
//   fint.Seek(0, soFromBeginning);
  kmax:=DFT_kmax; //  
  nmax:= DFT_nmax;
  ADC :=1000;  //

 T := 2*pi/nmax;
 sin_nmax.Seek(0, soFromBeginning);
 cos_nmax.Seek(0, soFromBeginning);

 SetLength(fdata, BufSize);

end;

{*************************************************}
procedure TDFT.Create_SinCos;
var k,n:word;

begin

 for k:=0 to DFT_kmax-1 do
  for n:=0 to DFT_nmax-1 do
   begin
     K_sin[n,k]:=round(sin(n*k*T)*ADC);
     K_cos[n,k]:=round(cos(n*k*T)*ADC);
   end;
end;
{*************************************************}

Function TDFT.ReDFTQ (kg:integer):real;
var
 sum,mul:longint;
 pr:integer;
 n:word;
 adcadc:real;
 S:integer;
begin
 sum:=0;
 S:= sizeof(pr);
 adcadc:=ADC*ADC;
 sin_nmax.Seek(kg*nmax*S, soFromBeginning);
 cos_nmax.Seek(kg*nmax*S, soFromBeginning);


 for n:=0 to nmax-1 do
   begin

    mul:=fdata[n];
    cos_nmax.ReadBuffer(pr,S);
    sum:=sum+mul*pr;
   end;
 ReDFTQ:=sum/adcadc;
end;
{*************************************************}
Function TDFT.ImDFTQ (kg:integer):real;

var
 sum,mul:longint;
 pr:integer;
 n:word;
 adcadc:real;
 S:integer;

begin
 sum:=0;
 S:= sizeof(pr);
 adcadc:=ADC*ADC;
 sin_nmax.Seek(kg*nmax*S, soFromBeginning);
 cos_nmax.Seek(kg*nmax*S, soFromBeginning);

 for n:=0 to nmax-1 do
  begin

    mul:=fdata[n];
    sin_nmax.ReadBuffer(pr,S);
    sum:=sum+mul*pr;
  end;
 ImDFTQ:=sum/adcadc;
end;
{*************************************************}
Function TDFT.ReDFTQ_Const (kg:integer):real;
var
 sum,mul:longint;
 n:word;
 adcadc:real;
begin
 adcadc:=ADC*ADC;
 sum:=0;
 for n:=0 to DFT_nmax-1 do
   begin
    mul:=fdata[n];
    sum:=sum+mul*K_cos[n,kg];
   end;
 ReDFTQ_Const:=sum/adcadc;
end;
{*************************************************}
Function TDFT.ImDFTQ_Const (kg:integer):real;

var
 sum,mul:longint;
 n:word;
 adcadc:real;
begin
 adcadc:=ADC*ADC;
 sum:=0;
 for n:=0 to DFT_nmax-1 do
  begin
   mul:=fdata[n];
   sum:=sum +mul*K_sin[n,kg];
  end;
 ImDFTQ_Const:=sum/adcadc;
end;
{*************************************************}

end.
