unit UnitMain;
//             
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MMSystem, ExtCtrls, UnitDFT, TeEngine, Series, TeeProcs, Chart,
  ComCtrls, StdCtrls;

  const
    discret = 40000;  // per second

  type TVolumeLevel=1..255;

  type

  TData16 = array [0..BufSize-1] of smallint;
  PData16 = ^TData16;

  TForm1 = class(TForm)
    Image1: TImage;
    ChartSpectr: TChart;
    StatusBar1: TStatusBar;
    Series1: TFastLineSeries;
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  public
    procedure OnWaveIn(var Msg: TMessage); message MM_WIM_DATA;
    procedure WCard;
    procedure DrawSignal(GraphBuf: array of smallint);
    procedure SetParam;
    procedure CreateSpectr;
    procedure CreateSpectr_Const;
    procedure MakeSoundOld((*Frequency{Hz}, Duration{mSec}: Integer; *)Volume: TVolumeLevel);
  end;

var
  Form1: TForm1;
  WaveFormatEx: TWaveFormatEx;
  h:HWAVE;//!!
  WaveIn: hWaveIn;
  hBuf: THandle;
  BufHead: TWaveHdr;

  woh:array[0..1]of WAVEHDR; //!!
  bufs:array[0..1,0..65535,0..1]of smallint;//!!
  fL:real=500;  //  
  fR:real=1500;  //  
  nL:real=0;
  nR:real=0;


  Bits16: boolean;
  Stop: boolean;
  AllData: Longint;
  DFT:TDFT;
  ScaleX:real;
  tt1,tt2,tt3,tt4:longint;
  period_capture:word;
  X_Chart: array[0..DFT_kmax-1] of string; //  
  Singl_Draw:boolean;

implementation

{$R *.dfm}

procedure callbackproc(h: integer;Msg,UserData,P1,P2:cardinal); stdcall;
var i:integer;
begin
if msg = WOM_DONE then
 begin
 for i:=0 to 65535 do
  begin
//  psmallint(cardinal(PWAVEHDR(p1)^.lpData)+i*4)^:=smallint(trunc( 32767*sin(2*pi*nL)));
  psmallint(cardinal(PWAVEHDR(p1)^.lpData)+i*4)^:=smallint(trunc( 1024*sin(2*pi*nL)));
  psmallint(cardinal(PWAVEHDR(p1)^.lpData)+i*4+2)^:=smallint(trunc( 2024*sin(2*pi*nR)));
  nL:=frac(nL+fL/WaveFormatEx.nSamplesPerSec);
  nR:=frac(nR+fR/WaveFormatEx.nSamplesPerSec);
  end;
 waveOutWrite(h,pointer(p1),sizeof(woh[0]));
 end;

end;


procedure TForm1.MakeSoundOld((*Frequency{Hz}, Duration{mSec}: Integer; *)Volume: TVolumeLevel);
  {writes tone to memory and plays it}
var
//  WaveFormatEx: TWaveFormatEx;
  MS: TMemoryStream;
  i, TempInt, DataCount, RiffCount: LongInt;
  SoundValue: byte;
  w: double; // omega ( 2 * pi * frequency)
const
  Mono: Word = $0001;
  SampleRate: Integer = 11025; // 8000, 11025, 22050, or 44100
  RiffId: string = 'RIFF';
  WaveId: string = 'WAVE';
  FmtId: string = 'fmt ';
  DataId: string = 'data';
begin
 { if Frequency > (0.6 * SampleRate) then
  begin
    ShowMessage(Format('Sample rate of %d is too Low to play a tone of %dHz',
      [SampleRate, Frequency]));
    Exit;
  end;}
  with WaveFormatEx do
  begin
    wFormatTag := WAVE_FORMAT_PCM;
    nChannels := Mono;
    nSamplesPerSec := SampleRate;
    wBitsPerSample := 8;
    nBlockAlign := (nChannels * wBitsPerSample) div 8;
    nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
    cbSize := 0;
  end;
  MS := TMemoryStream.Create;
  with MS do
  begin
    {Calculate length of sound data and of file data}
//    DataCount := bufcount;//(Duration * SampleRate) div 1000; // sound data
    DataCount := (500 * SampleRate) div 1000; // sound data
    RiffCount := Length(WaveId) + Length(FmtId) + SizeOf(DWORD) +
      SizeOf(TWaveFormatEx) + Length(DataId) + SizeOf(DWORD) + DataCount; // file data
    {write out the wave header}
    Write(RiffId[1], 4); // 'RIFF'
    Write(RiffCount, SizeOf(DWORD)); // file data size
    Write(WaveId[1], Length(WaveId)); // 'WAVE'
    Write(FmtId[1], Length(FmtId)); // 'fmt '
    TempInt := SizeOf(TWaveFormatEx);
    Write(TempInt, SizeOf(DWORD)); // TWaveFormat data size
    Write(WaveFormatEx, SizeOf(TWaveFormatEx)); // WaveFormatEx record
    Write(DataId[1], Length(DataId)); // 'data'
    Write(DataCount, SizeOf(DWORD)); // sound data size
    {calculate and write out the tone signal} // now the data values

//    w := 2 * Pi * Frequency; // omega
    w:=1500;

   for i := 1 to DataCount - 1 do
    begin
//      SoundValue := buffer[i];//127 + trunc(Volume * sin(i * w / SampleRate)); // wt = w * i / SampleRate
      SoundValue := 127 + trunc(Volume * sin(i * w / SampleRate)); // wt = w * i / SampleRate
      if soundvalue <>0 then Write(SoundValue, SizeOf(Byte));
    end;
    {now play the sound}
    sndPlaySound(MS.Memory, SND_MEMORY or SND_SYNC);
    MS.Free;
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
var   k:word;
  pr:real;
begin
  AllData := 0;
  Form1.Caption:='Sound-Agent';
  Form1.DoubleBuffered := True;
  Width:=1008;

  Image1.Picture.Bitmap.Width := Image1.width;
  Image1.Picture.Bitmap.Height:= Image1.height;
  with Image1.Picture.Bitmap.Canvas do begin
    Pen.Style   := psSolid;
    Pen.Color   := clRed;
    Brush.Style := bsSolid;
    Brush.Color := 0;
    FillRect(Rect(0, 0, Image1.Width, Image1.Height));
    FillRect(ClientRect);
  end;

  DFT := TDFT.Create;

  SetParam;
  ChartSpectr.TopAxis.Maximum:=DFT.kmax;
  ChartSpectr.TopAxis.Minimum:=0;
  ChartSpectr.BottomAxis.Maximum:=DFT.kmax * ScaleX;
  ChartSpectr.BottomAxis.Minimum:=0;

  tt1:=0;
  tt2:=0;
  tt3:=0;
  tt4:=0;

 for k:=0 to DFT.kmax-1 do
 begin
   pr:=k*ScaleX/DFT.nmax;
   X_Chart[k]:=format('%0.0f',[pr]);
   ChartSpectr.Series[0].AddXY(k,0,X_Chart[k]);
 end;
 Singl_Draw:=false;

  WCard;
end;

procedure TForm1.SetParam;
var k,n:integer;
    pr:integer;
    S:integer;
begin

 S:=Sizeof(pr);
 ScaleX:=discret;
 for k:=0 to DFT.kmax-1 do
  for n:=0 to DFT.nmax-1 do
   begin
    DFT.nkT:=n*k*DFT.T;
    pr:=round(sin(DFT.nkT)*DFT.ADC);
    DFT.sin_nmax.WriteBuffer(pr,S);
    pr:=round(cos(DFT.nkT)*DFT.ADC);
    DFT.cos_nmax.WriteBuffer(pr,S);
   end;
 DFT.Create_SinCos;  

end;

procedure TForm1.CreateSpectr;
var
 k:word;
 Re,Im,Ampl:real;
 F:integer;
 st:string;
 pr:real;
begin

 for k:=0 to DFT.kmax-1 do
 begin
   Re:=DFT.ReDFTQ(k);
   Im:=DFT.ImDFTQ(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
   if k=0 then Ampl:=0;
   ChartSpectr.Series[0].AddXY(k,Ampl);
 end;

end;
procedure TForm1.CreateSpectr_Const;
var
 k:word;
 Re,Im,Ampl:real;
 F:integer;
 st:string;
 pr:real;
begin

 for k:=0 to DFT_kmax-1 do
 begin
   Re:=DFT.ReDFTQ_Const(k);
   Im:=DFT.ImDFTQ_Const(k);
   Ampl:=Sqrt(Re*Re+Im*Im);

   if k=0 then Ampl:=0;

   DFT.fspectr[k]:=round(Ampl);
   ChartSpectr.Series[0].AddXY(k,DFT.fspectr[k],X_Chart[k]);

 end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //   ,  
  WCard;
//  FreeAndNil(DFT.sin_nmax);
//  FreeAndNil(DFT.cos_nmax);
end;

procedure TForm1.WCard;
var
//  header: TWaveFormatEx;
  BufLen: word;
  buf: pointer;

begin
  Stop := not Stop;
  if Stop then begin

    bits16 := True;   //  false  8 

{
  wf.wFormatTag:=WAVE_FORMAT_PCM;
  wf.nChannels:=2;    //2 
  wf.wBitsPerSample:=16;    //16 
wf.nBlockAlign:=(wf.nChannels * wf.wBitsPerSample)div 8;
  wf.nSamplesPerSec:=44100;    //44,1 
wf.nAvgBytesPerSec:=wf.nSamplesPerSec*wf.nBlockAlign;
waveOutOpen(@h,WAVE_MAPPER,@wf,cardinal(@callbackproc),0,CALLBACK_FUNCTION);
}


    with WaveFormatEx do begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := 1;
      nSamplesPerSec := discret;
      wBitsPerSample := integer(Bits16) * 8 + 8;
//       
      nBlockAlign := nChannels * (wBitsPerSample div 8);
//       
      nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
//      
      cbSize := 0;

    end;               

////////////////////
//////////////////

    WaveInOpen(Addr(WaveIn), WAVE_MAPPER, addr(WaveFormatEx), Handle, 0, CALLBACK_WINDOW);
    BufLen := WaveFormatEx.nBlockAlign * BufSize;
    hBuf := GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, BufLen);
    Buf := GlobalLock(hBuf);

    with BufHead do begin
      lpData := Buf;
      dwBufferLength := BufLen;
      dwFlags:= WHDR_BEGINLOOP
    end;

    WaveInPrepareHeader(WaveIn, Addr(BufHead), sizeof(BufHead));
    WaveInAddBuffer(WaveIn, addr(BufHead), sizeof(BufHead));
    WaveInStart(WaveIn);
  end
  else begin
    WaveInReset(WaveIn);
    WaveInUnPrepareHeader(WaveIn, addr(BufHead), sizeof(BufHead));
    WaveInClose(WaveIn);
    GlobalUnlock(hBuf);
    GlobalFree(hBuf);
  end;
end;

procedure TForm1.OnWaveIn;
var
  i: integer;
  tmpBuf: array of smallint;
  data16: PData16;
begin

  tt1:=gettickcount;
  period_capture:=abs(tt2-tt1);
  tt2:=tt1;
  if Bits16 then
  begin
    data16 := PData16(PWaveHdr(Msg.lParam)^.lpData);

    SetLength(tmpBuf, BufSize);
    for i := 0 to Length(tmpBuf) - 1 do tmpBuf[i] := data16^[i];



    tt3:=gettickcount;
    if not Singl_Draw then DrawSignal(tmpBuf);
    StatusBar1.Panels[1].Text:=inttostr(abs(gettickcount-tt3));
    tt3:=gettickcount;
    if not Singl_Draw then
    begin
      ChartSpectr.Series[0].Clear;
      CreateSpectr_Const;
    end;
    StatusBar1.Panels[2].Text:=inttostr(abs(gettickcount-tt3));
    StatusBar1.Panels[0].Text:='Period: '+inttostr(period_capture);
  end;

  if Stop then WaveInAddBuffer(WaveIn, PWaveHdr(Msg.lParam),SizeOf(TWaveHdr))
  else Stop:= True;
  Update;      //  -...
end;

procedure TForm1.DrawSignal(GraphBuf: array of smallint);
var i, tmpX, tmpY,pr: integer;
begin
  Image1.Refresh;

  with Image1.Picture.Bitmap.Canvas do begin
    Pen.Color   := clgreen;
    Brush.Color := 0;
    Rectangle(0, 0, Image1.Width, Image1.Height);
  end;

  Image1.Picture.Bitmap.Canvas.MoveTo(0, Image1.Height);
  for i:=0 to Length(GraphBuf) - 1 do begin

//    pr:= round(40*sin(i/8))+100;
//    GraphBuf[i]:=pr;

    tmpX := Round(i*Image1.Width/Length(GraphBuf));
//    tmpY := (Image1.Height * GraphBuf[i]) div 65536 + (Image1.Height div 2);
    tmpY := (Image1.Height * GraphBuf[i]) div 32768 + (Image1.Height div 2);

    Image1.Picture.Bitmap.Canvas.LineTo(tmpX, tmpY);
    DFT.fdata[i]:=GraphBuf[i];
  end;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (Button = mbLeft) then Singl_Draw:=true;
if (Button = mbRight) then Singl_Draw:=false;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 MakeSoundOld(16);
end;

procedure TForm1.Button1Click(Sender: TObject);
var  i:integer;
begin
    waveOutOpen(@h,WAVE_MAPPER,@WaveFormatEx,cardinal(@callbackproc),0,CALLBACK_FUNCTION);//!!
//    waveOutOpen(@h,WAVE_MAPPER,@WaveFormatEx,cardinal(@TForm1.callbackproc),0,CALLBACK_WINDOW);//!!

for i:=0 to 1 do
 begin
 fillchar(woh[i],sizeof(woh[i]),0);
 woh[i].lpData:=@(bufs[i]);
 woh[i].dwBufferLength:=sizeof(bufs[i]);
 woh[i].dwLoops:=1;
 waveOutPrepareHeader(h,@(woh[i]),sizeof(woh[i]));
 callbackproc(h,WOM_DONE,0,cardinal(@(woh[i])),0);
 end;
waveOutReStart(h);

end;

end.
